<?php
/**
 * image_downsized Addon 0.0.2
 *
 * @author heiko[dot]fritsch[at]gmx[dot]de Heiko Fritsch
 *
 * @package redaxo4
 * @version svn:$Id$
 */

if (OOAddon::isAvailable('image_resize')) {

	include_once(dirname(dirname(__FILE__)).'/image_resize/classes/class.thumbnail.inc.php');

  function rex_image_downsized($imagefile, $max_width=0, $max_height=0)  {
		global $REX;

		// ----- the original file
		$imagepath = dirname(dirname($REX['INCLUDE_PATH'])).'/files/'.$imagefile;

		// ----- if no limits given then return the original name
		if (!$max_width && !$max_height) return $imagefile;

		// ------ the original image file musts exist
	  if (!file_exists($imagepath)) return '';

		// ----- create resize parameters for image_resize
		$imgsize = getimagesize($imagepath);
		if (!$max_width) {
			$size = $max_height;
			$param = $max_height.'h__';
			$scale_h = $max_height/$imgsize[1];
			$scale_w = 1.0;
		} else if (!$max_height) {
			$size = $max_width;
			$param = $max_width.'w__';
			$scale_w = $max_width/$imgsize[0];
			$scale_h = 1.0;
		} else {
			$scale_w = $max_width/$imgsize[0];
			$scale_h = $max_height/$imgsize[1];
			if ($scale_w < 1.0 || $scale_h < 1.0) {
				$to_scale = true;
				if ($scale_w < $scale_h) {
					$size = $max_width;
					$max_height = 0;
					$param = $max_width.'w__';
				} else {
					$size = $max_height;
					$max_width = 0;
					$param = $max_height.'h__';
				}
			}
		}
		
		// ----- don't stretch!
		if ($scale_w >= 1.0 && $scale_h >= 1.0)
			return $imagefile;

		$cachepath = $REX['INCLUDE_PATH'].'/generated/files/image_resize__'.$param.$imagefile;
		if (!$param) $param=''.(0+$max_width).'x'.(0+$max_height).'.';
		$publicsubpath = 'addons/image_downsized/'.$param.$imagefile;
		$publicpath = dirname(dirname($REX['INCLUDE_PATH'])).'/files/'.$publicsubpath;

		// ----- return the existing resized file if any (and newer than the original)
	  if (file_exists($cachepath) && filectime($cachepath) > filectime($imagepath)) {
			// ----- copy internal cache file to public dir (if not done)
			if (!file_exists($publicpath))
				if (!copy($cachepath,$publicpath)) {
			    print 'Error copy failed: '.$cachepath.' -> '.$publicpath;
			    exit;
				}
			return $publicsubpath;
	  }
		
		// ----- check filesize limit
		$max_file_size = $REX['ADDON']['image_resize']['max_resizekb']*1024;
		if (filesize($imagepath)>$max_file_size) {
	    print 'Error file size to big: max '.$max_file_size.' kB';
	    exit;
	  }

		// ----- check pixel size limit
	  if ($size > $REX['ADDON']['image_resize']['max_resizepixel']) {
	    print 'Error size to big: max '.$REX['ADDON']['image_resize']['max_resizepixel'].' px';
	    exit;
	  }

	  // ----- start thumb class
	  $thumb = new rex_thumbnail($imagepath);

	  $thumb->img_filename = $imagefile;
  	$thumb->img_cachepath = $REX['INCLUDE_PATH'].'/generated/files/';

	  // ----- check method
	  if ($max_width) $thumb->size_width($size);
	  else if ($max_height) $thumb->size_height($size);

	  // ----- add default filters
	  $rex_filter = array_merge($rex_filter,$REX['ADDON']['image_resize']['default_filters']);

	  // ----- save cache
	  $thumb->generateImage($cachepath,false);
	  copy($cachepath,$publicpath);
		return $publicsubpath;

	}

} else if (OOAddon::isAvailable('image_manager')) {
	
  function rex_image_downsized($imagefile, $max_width=0, $max_height=0)  {
		global $REX;

		// ----- the original file
		$imagepath = dirname(dirname($REX['INCLUDE_PATH'])).'/files/'.$imagefile;

		// ----- if no limits given then return the original name
		if (!$max_width && !$max_height) return $imagefile;

		// ------ the original image file musts exist
	  if (!file_exists($imagepath)) return '';

		// ----- create resize parameters for image_resize
		$imgsize = getimagesize($imagepath);
		if (!$max_width) {
			$size = $max_height;
			$scale_h = $max_height/$imgsize[1];
			$scale_w = 1.0;
		} else if (!$max_height) {
			$size = $max_width;
			$scale_w = $max_width/$imgsize[0];
			$scale_h = 1.0;
		} else {
			$scale_w = $max_width/$imgsize[0];
			$scale_h = $max_height/$imgsize[1];
			if ($scale_w < 1.0 || $scale_h < 1.0) {
				$to_scale = true;
				if ($scale_w < $scale_h) {
					$size = $max_width;
					$max_height = 0;
				} else {
					$size = $max_height;
					$max_width = 0;
				}
			}
		}
		
		// ----- don't stretch!
		if ($scale_w >= 1.0 && $scale_h >= 1.0)
			return $imagefile;

		$cachepath = $REX['INCLUDE_PATH'].'/generated/files/image_resize__'.$param.$imagefile;
		if (!$param) $param=''.(0+$max_width).'x'.(0+$max_height).'.';
		$publicsubpath = 'addons/image_downsized/'.$param.$imagefile;
		$publicpath = dirname(dirname($REX['INCLUDE_PATH'])).'/files/'.$publicsubpath;

		// ----- return the existing resized file if any (and has the same creation time as the original)
	  if (file_exists($publicpath) && filectime($publicpath) == filectime($imagepath)) {
			return $publicsubpath;
	  }
		
    $params = array(
			'style' => 'maximum',
			'allow_enlarge' => 'not_enlarge',
		);

	  // ----- check method
	  if ($max_width) $params['width']=$max_width;
	  else if ($max_height) $params['height']=$max_height;

	  // ----- start image && effect class
		include_once(dirname(dirname(__FILE__)).'/image_manager/classes/effects/class.rex_effect_resize.inc.php');
		$thumb = new rex_image($imagepath);
		$thumb->prepare();
		$effect = new rex_effect_resize;
  	$effect->setImage($thumb);
		$effect->setParams($params);
  	$effect->execute();
		$thumb->_sendImage($publicpath, filectime($imagepath));

		return $publicsubpath;

	}
	
} else if (OOAddon::isAvailable('image_downsized')) {

    rex_warning('The AddOn "Image Resize" or "Image Manager" must be installed and activated!');

}

if (isset($REX['REDAXO']) && $REX['REDAXO']==1) {
	include('config.inc.backend.php');
}

?>